<template>
	<view class="content flex flex_column">
		<view class="searchBar">
			<view class="p-title">
				<text></text>
				<view class="shelfName flex align_center">
					<view>{{shelfName}}</view>
				</view>
				<view class="btns" @click="showTab = true">筛选<u-icon size="20" name="arrow-down"></u-icon></view>
			</view>
			<view class="search flex align_center">
				<view class="input">
					<u-search 
					v-model="queryWord" 
					@custom="getpartList" 
					@search="getpartList" 
					@clear="clearSearch" 
					@input="$u.debounce(changeSearch, 800)"
					bg-color="#fff" 
					:show-action="false"
					placeholder="请输入产品编码或名称搜索"></u-search>
				</view>
				<view class="icon" @click="toScan">
					<u-icon name="scan"></u-icon>
				</view>
			</view>
		</view>
		<view class="check-list">
			<scroll-view scroll-y class="scroll-view" @scrolltolower="onreachBottom">
				<view class="partList-list-box" v-for="item in partList" :key="item.id">
					<view class="product flex align_center" @click="toEdit(item)">
						<view class="flex align_center flex_1">
							<view class="pimgs">
								<u-image :src="item.productEntity&&item.productEntity.images?item.productEntity.images:`../../static/${$config('themePath')}/def_img@2x.png`" width="128" height="128" border-radius="10"></u-image>
							</view>
							<view class="pinfo">
								<view class="pname">
									<text>{{item.shelfPlaceCode}}</text>{{item.productEntity&&item.productEntity.code}}
								</view>
								<view class="ptxt flex align_center justify_between">
									<view>
										<text class="pcode">{{item.productEntity&&item.productEntity.productName}}</text>
									</view>
								</view>
							</view>
						</view>
					</view>
				</view>
				<view v-if="partList&&partList.length==0">
					<u-empty v-if="status!='loading'" :src="`/static/${$config('themePath')}/def_no_data@3x.png`" icon-size="180" :text="noDataText" mode="list" :margin-top="50"></u-empty>
				</view>
				<view style="padding: 20upx;" v-if="total>pageSize || status=='loading'">
					<u-loadmore :status="status" />
				</view>
			</scroll-view>
		</view>
		<!-- 筛选项 -->
		<u-popup v-model="showTab" mode="right" width="70%">
			<view class="tabBox flex flex_column">
				<view class="tabs">
					<view class="flex">
						<view :class="item==curTab?'active':''" v-for="item in placeTab" :key="item" @click="curTab=curTab==item?'':item">{{item}}层</view>
					</view>
				</view>
				<view class="btns">
					<u-button class="handle-btn" shape="circle" size="medium" hover-class="none" @click="handleClear">重置</u-button>
					<u-button class="handle-btn" shape="circle" size="medium" hover-class="none" :custom-style="customBtnStyle" @click="clearSearch">查询</u-button>
				</view>
			</view>
		</u-popup>
	</view>
</template>

<script>
	import { getShelfProductList,getProductPlace } from '@/api/shelf'
	export default {
		data() {
			return {
				queryWord: '',
				shelfName:'',
				shelfSn: '',
				pageNo:1,
				pageSize: 10,
				total: 0, // 列表总数
				noDataText: '暂无产品',
				status: 'loading',
				partList: [],
				showTab: false,
				placeTab: [],
				curTab: '',
				customBtnStyle: {  //  自定义按钮样式
					borderColor: this.$config('primaryColor'),
					backgroundColor: this.$config('primaryColor'),
					color: '#fff'
				},
			}
		},
		onLoad(opts) {
			this.$store.state.vuex_tempData = null
			this.shelfName = opts.shelfName
			this.shelfSn = opts.shelfSn
			this.getShelfPlace()
		},
		onShow() {
			this.changeSearch()
		},
		onBackPress() {
			if(this.showTab){
				this.showTab = false
				return true
			}
		},
		methods: {
			//编辑货位
			toEdit(item){
				const type = 'edit'
				const params = Object.assign({shelfSn: this.shelfSn,shelfName: this.shelfName},item)
				this.$store.state.vuex_tempData = params
				uni.navigateTo({
					url: "/pages/shelfSetting/editShelfHw?type=" + type
				})
			},
			getShelfPlace(flag){
				getProductPlace({ shelfSn: this.shelfSn }).then(res => {
				  if (res.status == 200) {
					for(let a in res.data){
						this.placeTab.push(a)
					}
					if(!flag){
					  this.curTab = ''
					}
				  } else {
				    this.placeTab = []
				  }
				})
			},
			handleClear(){
				this.curTab = ''
				this.clearSearch()
			},
			clearSearch(){
				this.queryWord = ''
				this.changeSearch()
			},
			changeSearch(){
				this.pageNo = 1
				this.partList = []
				this.getpartList()
			},
			// 获取数字货架列表
			getpartList(){
				const _this = this
				let params = {
				    pageNo: this.pageNo,
				    pageSize: this.pageSize,
					shelfSn: this.shelfSn,
					queryWord: this.queryWord,
					shelfPlaceCodeHead: this.curTab
				}
				_this.status = 'loading'
				getShelfProductList(params).then(res => {
					uni.hideLoading()
					if(res.status == 200){
						let list = res.data.list
						console.log(list)
						if (list && list.length){
							// 分页 拼接数据
							if (_this.pageNo != 1) {
								_this.partList = _this.partList ? _this.partList.concat(list) : list
							} else {
								_this.partList = list
							}
							this.total = res.data.count
							if (_this.partList.length == res.data.count) {
								_this.status = 'nomore'
							} else {
								_this.status = 'loadmore'
							}
						} else {
							_this.partList = list || []
							this.total = 0
							_this.status = 'nomore'
						}
						_this.noDataText = '暂无匹配产品'
					}else{
						_this.status = 'loadmore'
						_this.partList = []
						_this.total = 0
						_this.noDataText = res.message ? res.message : '网络似乎出错了，请稍后再试'
					}
					this.showTab = false
				})
			},
			// 加载更多
			onreachBottom () {
				if(this.partList.length < this.total ){
					this.pageNo++
					this.getpartList()
				}else{
					this.status = "nomore"
				}
			},
			// 扫描
			toScan(){
				this.mpaasScanModule = uni.requireNativePlugin("wss-scan")
				this.mpaasScanModule.scan(
				{
					"scanMode":"Customized",
					"scanStyle":{
						"scanFrameSizePlus":{"width":250,"height":250},
						"scanFrameSize":200,
						"scanLight":"visible",
						"scanText":"对准条形码/二维码进行识别",
						"scanTitle":"扫码搜索货位产品",
					}
				},
				(result) => {
					console.log(result)
					if(result.scanStatus == 1){
						this.scanResult(result)
					}
				})
			},
			// 扫描结果
			scanResult(data){
				const params = {
					pageNo: 1,
					pageSize:1,
					shelfSn: this.shelfSn
				}
				// 二维码
				if(data.scanType == 'QRCODE'){
					const ret = data.scanValue.split("&")
					params.queryWord = ret[1] // 产品编码
				}else{
					params.qrCode = data.scanValue
				}
				
				getShelfProductList(params).then(res => {
					console.log(res)
					if(res.status == 200){
						if(res.data&&res.data.list.length){
							this.toEdit(res.data.list[0])
						}else{
							uni.showToast({
								icon: "none",
								title: "产品不属于此货架，请重新扫描",
								duration: 5000
							})
						}
					}
				})
			}
		}
	}
</script>

<style lang="less">
.content{
	height: 100vh;
	width: 100%;
	padding: 0 0.5rem;
	background: #fff;
	.searchBar{
		padding: 0 0.3rem 0.3rem;
		.p-title{
			padding: 0 10rpx;
			display: flex;
			align-items: center;
			color: #222;
			font-size: 30rpx;
			> text{
					display: block;
					height: 30rpx;
					width: 6rpx;
					background: #0485F6;
					margin-right: 10rpx;
					border-radius: 10rpx;
				}
			.shelfName{
				flex-grow: 1;
				font-weight: bold;
				width: 80%;
				> view{
					overflow: hidden;
					white-space: nowrap;
					text-overflow: ellipsis;
				}
			}
			.btns{
				width:100rpx;
				text-align: right;
				font-size: 28rpx;
				color: #0485F6;
			}
		}
		.search{
			margin-top: 15upx;
			padding: 0.1rem;
			border-radius: 50rpx;
			border:1rpx solid #eee;
			.input{
				flex-grow: 1;
				padding: 4rpx;
			}
			.icon{
				width: 13%;
				text-align: center;
				font-size: 46rpx;
				color: #999;
			}
		}
	}
	.check-list{
		flex-grow: 1;
		.scroll-view{
			height: calc(100vh - 150rpx);
			box-sizing: border-box;
		}
		.partList-list-box{
			padding: 20rpx 30rpx;
			border-bottom: 2rpx solid #f5f5f5;
			&:last-child{
				border:0;
			}
			.product{
				flex-grow: 1;
				&:active{
					opacity: 0.6;
					background-color: #f8f8f8;
				}
				.pinfo{
					flex-grow: 1;
					padding-left: 20rpx;
					.pname{
						font-size: 28rpx;
						color: #191919;
						margin-bottom: 10rpx;
						text{
							font-weight: normal;
							margin-right: 6rpx;
							padding: 0 10rpx;
							background: rgba(3, 54, 146, 0.15);
							border-radius: 100rpx;
							color: #033692;
							font-size: 24rpx;
						}
					}
					.ptxt{
						font-size: 28rpx;
						color: #333;
						font-weight: bold;
						.pnums{
							color: #222;
						}
					}
				}
			}
		} 
	}
	
	// 筛选
	.tabBox{
		height: 100vh;
		.tabs{
			flex-grow: 1;
			overflow: auto;
			padding: 20rpx;
			> view{
				flex-wrap: wrap;
				justify-content: space-between;
				> view{
					width: 45%;
					border: 1rpx solid #ddd;
					padding: 15rpx;
					border-radius: 50rpx;
					text-align: center;
					margin-bottom: 15rpx;
				}
				.active{
					border:0;
					background-color: #0485F6;
					color: #fff;
				}
			}
		}
		.btns{
			display: flex;
			padding: 20upx;
			justify-content: space-between;
			.handle-btn {
				font-size: 28upx;
			}
		}
	}
}
</style>
